'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _nodeFetch = require('node-fetch');

var _nodeFetch2 = _interopRequireDefault(_nodeFetch);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var pokeauth = {
  apiKey: 'AIzaSyDIO0qyF90wiDcg2uYXVQf_RuJnOLlbr68',
  databaseUrl: 'https://pokeauth.firebaseio.com',
  developer: {
    id: '',
    token: '',
    refreshToken: '',
    expiry: 0
  },
  login: function () {
    var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(email, password) {
      var expires, url, result, developer;
      return _regenerator2.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // set token expiry time (1 hour)
              expires = pokeauth.getExpiry();
              // get token

              url = 'https://www.googleapis.com/identitytoolkit/v3/relyingparty/verifyPassword?key=' + pokeauth.apiKey;
              _context.next = 4;
              return (0, _nodeFetch2.default)(url, {
                method: 'POST',
                headers: {
                  'Content-Type': 'application/json; charset=UTF-8'
                },
                body: (0, _stringify2.default)({
                  email: email,
                  password: password,
                  returnSecureToken: true
                })
              });

            case 4:
              result = _context.sent;
              _context.next = 7;
              return result.json();

            case 7:
              developer = _context.sent;

              pokeauth.developer = {
                id: developer.localId,
                token: developer.idToken,
                refreshToken: developer.refreshToken,
                expiry: expires
              };

            case 9:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function login(_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }(),
  getUserToken: function () {
    var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(uid) {
      var now, url, result, access;
      return _regenerator2.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              now = new Date().getTime();

              if (!(now >= pokeauth.developer.expiry)) {
                _context2.next = 4;
                break;
              }

              _context2.next = 4;
              return pokeauth.refresh();

            case 4:
              url = pokeauth.databaseUrl + '/users/' + uid + '/access.json?auth=' + pokeauth.developer.token;
              _context2.next = 7;
              return (0, _nodeFetch2.default)(url, {
                method: 'GET',
                headers: {
                  'Content-Type': 'application/json; charset=UTF-8'
                }
              });

            case 7:
              result = _context2.sent;
              _context2.next = 10;
              return result.json();

            case 10:
              access = _context2.sent;
              return _context2.abrupt('return', access);

            case 12:
            case 'end':
              return _context2.stop();
          }
        }
      }, _callee2, undefined);
    }));

    return function getUserToken(_x3) {
      return _ref2.apply(this, arguments);
    };
  }(),
  refresh: function () {
    var _ref3 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3() {
      var expires, url, result, developer;
      return _regenerator2.default.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              expires = pokeauth.getExpiry();
              // refresh token

              url = 'https://securetoken.googleapis.com/v1/token?key=' + pokeauth.apiKey;
              _context3.next = 4;
              return (0, _nodeFetch2.default)(url, {
                method: 'POST',
                headers: {
                  'Content-Type': 'application/json; charset=UTF-8'
                },
                body: (0, _stringify2.default)({
                  grantType: 'refresh_token',
                  refreshToken: pokeauth.developer.refreshToken
                })
              });

            case 4:
              result = _context3.sent;
              _context3.next = 7;
              return result.json();

            case 7:
              developer = _context3.sent;

              pokeauth.developer = {
                id: developer.user_id,
                token: developer.id_token,
                refreshToken: developer.refresh_token,
                expiry: expires
              };

            case 9:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, undefined);
    }));

    return function refresh() {
      return _ref3.apply(this, arguments);
    };
  }(),
  getExpiry: function getExpiry() {
    var now = new Date();
    now.setHours(now.getHours() + 1);
    return now.getTime();
  }
};

exports.default = pokeauth;